
#include "cca.h"

#ifdef NO_PURE_VIRTUAL
#include "stdPorts.h"
#include "ports/StringConsumerPort.h"
#include "ports/TimeProducerPort.h"
#include <exception>
#include <stdexcept> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define PURE_DIE(func_name) \
    fprintf(stderr,"Error: %s This is virtual function, you should not be here\n",func_name); \
    std::string msg_exception = func_name; msg_exception += " This is virtual function, you should not be here\n"; \
    throw std::logic_error(msg_exception)  
//    throw
#endif // NO_PURE_VIRTUAL

char *classic::gov::cca::Version::name() {
  return (char *)"Classic Common Component Architecture 0.5.7 Sandia/CA";
}

char *classic::gov::cca::Version::id() {
  return (char *)"0.5.7";
}

int classic::gov::cca::Version::Major() { return 0; }

int classic::gov::cca::Version::Minor() { return 5; }

int classic::gov::cca::Version::Patch() { return 7; }



#ifdef NO_PURE_VIRTUAL

char* classic::gov::cca::PortInfo::getType() { 
        PURE_DIE("classic::gov::cca::PortInfo::getType"); }
char* classic::gov::cca::PortInfo::getName() { 
        PURE_DIE("classic::gov::cca::PortInfo::getName"); }
char* classic::gov::cca::PortInfo::getProperty(char* name) { 
        PURE_DIE("classic::gov::cca::PortInfo::getProperty"); }

char* classic::gov::cca::ComponentID::toString() { 
        PURE_DIE("classic::gov::cca::ComponentID::toString"); }

classic::gov::cca::PortInfo* classic::gov::cca::Services::createPortInfo(CONST char *name, 
        CONST char *type, CONST char** properties) { 
        PURE_DIE("classic::gov::cca::Services::createPortInfo"); }
classic::gov::cca::Port* classic::gov::cca::Services::getPort(CONST char *name) 
        { PURE_DIE("classic::gov::cca::Services::getPort"); }
classic::gov::cca::Port* classic::gov::cca::Services::getPort(const std::string & name) 
        { PURE_DIE("classic::gov::cca::Services::getPort"); }
void classic::gov::cca::Services::releasePort(CONST char *name) 
        { PURE_DIE("classic::gov::cca::Services::releasePort"); }
void classic::gov::cca::Services::releasePort(const std::string & name) 
        { PURE_DIE("classic::gov::cca::Services::releasePort"); }
int classic::gov::cca::Services::registerUsesPort(PortInfo *name_and_type) 
        { PURE_DIE("classic::gov::cca::Services::registerUsesPort"); }
int classic::gov::cca::Services::registerUsesPort(const std::string & portName, const std::string & portType) 
        { PURE_DIE("classic::gov::cca::Services::registerUsesPort"); }
int classic::gov::cca::Services::unregisterUsesPort(CONST char *name) 
        { PURE_DIE("classic::gov::cca::Services::unregisterUsesPort"); }
int classic::gov::cca::Services::unregisterUsesPort(const std::string & name) 
        { PURE_DIE("classic::gov::cca::Services::unregisterUsesPort"); }
int classic::gov::cca::Services::addProvidesPort(Port *inPort, PortInfo *name) 
        { PURE_DIE("classic::gov::cca::Services::addProvidesPort"); }
int classic::gov::cca::Services::addProvidesPort(Port *inPort, const std::string & portName, 
         const std::string & portType) { PURE_DIE(" classic::gov::cca::Services::addProvidesPort"); }
void classic::gov::cca::Services::removeProvidesPort(CONST char *name) 
        { PURE_DIE("classic::gov::cca::Services::removeProvidesPort"); }
void classic::gov::cca::Services::removeProvidesPort(const std::string & name) 
        { PURE_DIE("classic::gov::cca::Services::removeProvidesPort"); }
classic::gov::cca::ComponentID* classic::gov::cca::Services::getComponentID() 
        { PURE_DIE("classic::gov::cca::Services::getComponentID"); }

void classic::gov::cca::Component::setServices(Services *cc) 
        { PURE_DIE("classic::gov::cca::Component::setServices"); }


// ports interface

int classic::gov::cca::GoPort::go() { PURE_DIE("classic::gov::cca::GoPort::go"); }

int classic::gov::cca::ConnectionEvent::connected() 
        { PURE_DIE("classic::gov::cca::ConnectionEvent::connected"); }
int classic::gov::cca::ConnectionEvent::disconnected()
        { PURE_DIE("classic::gov::cca::ConnectionEvent::disconnected"); }
classic::gov::cca::PortInfo* classic::gov::cca::ConnectionEvent::getPortInfo()
        { PURE_DIE("classic::gov::cca::ConnectionEvent::getPortInfo"); }
void* classic::gov::cca::ConnectionEvent::getOpqTypeMapSharedPtrAddress()
        { PURE_DIE("classic::gov::cca::ConnectionEvent::getOpqTypeMapSharedPtrAddress"); }

void classic::gov::cca::ConnectionEventListener::connectionActivity(ConnectionEvent* evt)
        { PURE_DIE("classic::gov::cca::ConnectionEventListener::connectionActivity"); }

void classic::gov::cca::ConnectionEventService::addConnectEventListener(ConnectionEventListener* l)
        { PURE_DIE("classic::gov::cca::ConnectionEventService::addConnectEventListener"); }
void classic::gov::cca::ConnectionEventService::addDisconnectEventListener(ConnectionEventListener* l)
        { PURE_DIE("classic::gov::cca::ConnectionEventService::addDisconnectEventListener"); }
void classic::gov::cca::ConnectionEventService::removeConnectEventListener(ConnectionEventListener* l)
        { PURE_DIE("classic::gov::cca::ConnectionEventService::removeConnectEventListener"); }
void classic::gov::cca::ConnectionEventService::removeDisconnectEventListener(ConnectionEventListener* l)
        { PURE_DIE("classic::gov::cca::ConnectionEventService::removeDisconnectEventListener"); }

const std::string classic::gov::cca::KeyValuePort::getValue(const std::string & key)
        { PURE_DIE("classic::gov::cca::KeyValuePort::getValue"); }
void classic::gov::cca::KeyValuePort::setValue(const ::std::string & key, const ::std::string & value)
        { PURE_DIE("classic::gov::cca::KeyValuePort::setValue"); }
const ::std::string classic::gov::cca::KeyValuePort::remove( const ::std::string & key)
        { PURE_DIE("classic::gov::cca::KeyValuePort::remove"); }
::std::vector< ::std::string >  classic::gov::cca::KeyValuePort::getKeys()
        { PURE_DIE("classic::gov::cca::KeyValuePort::getKeys"); }


void classic::gov::cca::JPrintfPort::p(char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::p"); }
void classic::gov::cca::JPrintfPort::p(char const* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::p"); }
void classic::gov::cca::JPrintfPort::pn(char * msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::pn"); }
void classic::gov::cca::JPrintfPort::pn(const char * msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::pn"); }
void classic::gov::cca::JPrintfPort::e(char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::e"); }
void classic::gov::cca::JPrintfPort::e(const char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::e"); }
void classic::gov::cca::JPrintfPort::en(char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::en"); }
void classic::gov::cca::JPrintfPort::en(const char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::en"); }
void classic::gov::cca::JPrintfPort::l(char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::l"); }
void classic::gov::cca::JPrintfPort::l(const char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::l"); }
void classic::gov::cca::JPrintfPort::ln(char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::ln"); }
void classic::gov::cca::JPrintfPort::ln(const char* msg)
        { PURE_DIE("classic::gov::cca::JPrintfPort::ln"); }


#if HAVE_PRINTFPORT

void classic::gov::cca::PrintfPort::p(char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::p"); }
void classic::gov::cca::PrintfPort::p(char const* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::p"); }
void classic::gov::cca::PrintfPort::pn(char * fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::pn"); }
void classic::gov::cca::PrintfPort::pn(const char * fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::pn"); }
void classic::gov::cca::PrintfPort::e(char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::e"); }
void classic::gov::cca::PrintfPort::e(const char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::e"); }
void classic::gov::cca::PrintfPort::en(char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::en"); }
void classic::gov::cca::PrintfPort::en(const char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::en"); }
void classic::gov::cca::PrintfPort::l(char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::l"); }
void classic::gov::cca::PrintfPort::l(const char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::l"); }
void classic::gov::cca::PrintfPort::ln(char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::ln"); }
void classic::gov::cca::PrintfPort::ln(const char* fmt, ...)
        { PURE_DIE("classic::gov::cca::PrintfPort::ln"); }

#endif // HAVE_PRINTFPORT


void classic::gov::cca::StringConsumerPort::setString(const char* s)
        { PURE_DIE("classic::gov::cca::StringConsumerPort::setString"); }

char* classic::gov::cca::TimeProducerPort::getTime()
        { PURE_DIE("classic::gov::cca::TimeProducerPort::getTime"); }


#if 0

char* esi::Argv::get(int index) { PURE_DIE("esi::Argv::get"); }
int   esi::Argv::getArgCount() { PURE_DIE("esi::Argv::getArgCount"); }
void  esi::Argv::appendArg(const char *arg) { PURE_DIE("esi::Argv::appendArg"); }

int classic::gov::cca::KeyValueEnumerated::setString(const char *key, const char *value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setString"); }
int classic::gov::cca::KeyValueEnumerated::setFloat(const char *key, float value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setFloat"); }
int classic::gov::cca::KeyValueEnumerated::setDouble(const char *key, double value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setDouble"); }
int classic::gov::cca::KeyValueEnumerated::setLongDouble(const char *key, long double value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setLongDouble"); }
int classic::gov::cca::KeyValueEnumerated::setChar(const char *key, char value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setChar"); }
int classic::gov::cca::KeyValueEnumerated::setShort(const char *key, short value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setShort"); }
int classic::gov::cca::KeyValueEnumerated::setInt(const char *key, int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setInt"); }
int classic::gov::cca::KeyValueEnumerated::setLong(const char *key, long int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setLong"); }
int classic::gov::cca::KeyValueEnumerated::setLongLong(const char *key, long long int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setLongLong"); }
int classic::gov::cca::KeyValueEnumerated::setUnsignedChar(const char *key, unsigned char value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setUnsignedChar"); }
int classic::gov::cca::KeyValueEnumerated::setUnsignedShort(const char *key, unsigned short value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setUnsignedShort"); }
int classic::gov::cca::KeyValueEnumerated::setUnsignedInt(const char *key, unsigned int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setUnsignedInt"); }
int classic::gov::cca::KeyValueEnumerated::setUnsignedLong(const char *key, unsigned long int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setUnsignedLong"); }
int classic::gov::cca::KeyValueEnumerated::setUnsignedLongLong(const char *key, unsigned long long int value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setUnsignedLongLong"); }
int classic::gov::cca::KeyValueEnumerated::setBool(const char *key, bool boolProp)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setBool"); }
int classic::gov::cca::KeyValueEnumerated::setPointer(const char *key, void *objProp)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::setPointer"); }
int classic::gov::cca::KeyValueEnumerated::getString(const char * propName, const char *& value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getString"); }
int classic::gov::cca::KeyValueEnumerated::getFloat(const char * propName, Float & value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getFloat"); }
int classic::gov::cca::KeyValueEnumerated::getInt(const char * propName, Int & value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getInt"); }
int classic::gov::cca::KeyValueEnumerated::getBool(const char * propName, bool & value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getBool"); }
int classic::gov::cca::KeyValueEnumerated::getPointer(const char * propName, void * & value)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getPointer"); }
int classic::gov::cca::KeyValueEnumerated::unset(const char *propName, void * & pointerOut)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::unset"); }
int classic::gov::cca::KeyValueEnumerated::getKeys(Argv * keylist)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getKeys"); }
int classic::gov::cca::KeyValueEnumerated::getKeysSupported(Argv * keylist)
        { PURE_DIE("classic::gov::cca::KeyValueEnumerated::getKeysSupported"); }

int classic::gov::cca::KeyValueTyped::set(const char *key, enum RawData::Type type, void * value)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::set"); }
int classic::gov::cca::KeyValueTyped::get(const char * key, enum RawData::Type type, void * valuePtr)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::get"); }
void classic::gov::cca::KeyValueTyped::unset(const char *propName)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::unset"); }
int classic::gov::cca::KeyValueTyped::setString(const char *key, const char *value)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::setString"); }
char* classic::gov::cca::KeyValueTyped::getString(const char * key)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::getString"); }
void classic::gov::cca::KeyValueTyped::getKeys(Argv * keylist)
        { PURE_DIE("classic::gov::cca::KeyValueTyped::getKeys"); }

MPI_Comm classic::gov::cca::MPIBorrow::borrowComm(int tagCount, int *tagList, int &key)
        { PURE_DIE("classic::gov::cca::MPIBorrow::borrowComm"); }
void     classic::gov::cca::MPIBorrow::returnComm(MPI_Comm, int tagCount, int *tagList, int key)
        { PURE_DIE("classic::gov::cca::MPIBorrow::returnComm"); }

MPI_Comm classic::gov::cca::MPIService::getComm()
        { PURE_DIE("classic::gov::cca::MPIService::getComm"); }
void     classic::gov::cca::MPIService::releaseComm(MPI_Comm m)
        { PURE_DIE("classic::gov::cca::MPIService::releaseComm"); }

char* classic::gov::cca::RawData::getName()
        { PURE_DIE("classic::gov::cca::RawData::getName"); }
int classic::gov::cca::RawData::getNumberOfBuffers()
        { PURE_DIE("classic::gov::cca::RawData::getNumberOfBuffers"); }
void classic::gov::cca::RawData::getBufferInfo(int bufferIndex, 
        const char* & elementName, enum RawDataType & elementType,
        int & elementCount, void* & buffer)
        { PURE_DIE("classic::gov::cca::RawData::getBufferInfo"); }
unsigned long classic::gov::cca::RawData::sizeofDataType(enum RawDataType)
        { PURE_DIE("classic::gov::cca::RawData::sizeofDataType"); }

void classic::gov::cca::StringConsumerPort::setString(const char* s)
        { PURE_DIE("classic::gov::cca::StringConsumerPort::setString"); }

char* classic::gov::cca::TimeProducerPort::getTime()
        { PURE_DIE("classic::gov::cca::TimeProducerPort::getTime"); }

//        { PURE_DIE(""); }

#endif // 0

#endif // NO_PURE_VIRTUAL
